C
      SUBROUTINE FFLD
C     FFLD CALCULATES THE FAR ZONE RADIATED ELECTRIC FIELDS,
C     THE FACTOR EXP(J*K*R)/(R/LAMDA) NOT INCLUDED
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      COMMON  /ANGL/ SALP( NM)
      COMMON/PTDAT/PHX,PHY,ROZ,THZ,ZTH,ZPH
      INCLUDE 'crnt.inc'
      DIMENSION  CAB(NM), SAB(NM)
      EQUIVALENCE(CAB,ALP),(SAB,BET)
      DATA PI/3.141592653589793D0/
      DATA TP/6.283185307179586D0/
      ROX=- THZ* PHY
      ROY= THZ* PHX
      ZIX=(0.,0.)
      ZIY=(0.,0.)
      ZIZ=(0.,0.)
C
C     LOOP OVER STRUCTURE SEGMENTS
      DO 17  I=1, N
      OMEGA=-( ROX* CAB( I)+ ROY* SAB( I)+ ROZ* SALP( I))
      EL= PI* SI( I)
      SILL= OMEGA* EL
      TOP= EL+ SILL
      BOT= EL- SILL
      IF( ABS( OMEGA).LT.1.D-9) GOTO 5
      AOO=2* SIN( SILL)/ OMEGA
      GOTO 6
    5 AOO=(2- 0.33333333333333333333D0*(OMEGA*EL)**2)* EL
    6 IF( ABS( TOP).LT.1.D-9) GOTO 7
      TOO= SIN( TOP)/ TOP
      GOTO 8
    7 TOO=1-TOP*TOP/6
    8 IF( ABS( BOT).LT.1.D-9) GOTO 9
      BOO= SIN( BOT)/ BOT
      GOTO 10
    9 BOO=1-BOT*BOT/6
   10 CONTINUE
C
C     SUMMATION FOR FAR FIELD INTEGRAL
      ZXA=CMPLX(COS(TP*(X(I)*ROX+Y(I)*ROY+RXZ(I)*ROZ)),
     &    SIN(TP*(X(I)*ROX+Y(I)*ROY+RXZ(I)*ROZ)))*
     &    CMPLX( AOO*AIR(I)+EL*((BOO-TOO)*BII(I)+(BOO+TOO)*CIR(I)) ,
     &           AOO*AII(I)-EL*((BOO-TOO)*BIR(I)-(BOO+TOO)*CII(I)) )
      ZIX= ZIX+ ZXA* CAB( I)
      ZIY= ZIY+ ZXA* SAB( I)
      ZIZ= ZIZ+ ZXA* SALP( I)
   17 CONTINUE
C      WRITE(*,*)'ZIX',ZIX
C      WRITE(*,*)'ZIY',ZIY
C      WRITE(*,*)'ZIZ',ZIZ
C      WRITE(*,*)'PHX',PHX
C      WRITE(*,*)'PHY',PHY
C      WRITE(*,*)'ROZ',ROZ

      ZTH= ZIX* ROZ* PHY+ ZIY* ROZ* PHX+ ZIZ* THZ
      ZPH= ZIX* PHX+ ZIY* PHY
C      WRITE(*,*)ZTH
C      STOP
      RETURN
      END
