      SUBROUTINE INTX( EL1, EL2, B, IJ, SGR, SGI)
C     INTX PERFORMS NUMERICAL INTEGRATION OF EXP(JKR)/R BY THE METHOD OF
C     VARIABLE INTERVAL WIDTH ROMBERG INTEGRATION.  THE INTEGRAND VALUE
C     IS SUPPLIED BY SUBROUTINE GF.
C
      INCLUDE 'prec.inc'
      PARAMETER (CNVLIM=1.D-6)
      DATA NMX/65536/
      DATA NTS /4/
      VZ= EL1
      VZE= EL2
      IF( IJ.EQ.0) VZE=0.
      S= VZE- VZ
      FNM= NMX
      EP= S/(10 * FNM)

      VZEND= VZE- EP
      SGR=0.
      SGI=0.
      NS= 1
      NT=0
      CALL GF( VZ, G1R, G1I)
    1 FNS= NS
      DZ= S/ FNS
      VZP= VZ+ DZ
      IF( VZP- VZE) 3,3,2
    2 DZ= VZE- VZ
      IF( ABS( DZ)- EP) 17,17,3
    3 DZOT= DZ/2
      VZP= VZ+ DZOT
      CALL GF( VZP, G3R, G3I)
      VZP= VZ+ DZ
      CALL GF( VZP, G5R, G5I)
    4 T00R=( G1R+ G5R)* DZOT
      T00I=( G1I+ G5I)* DZOT
      T01R=( T00R+ DZ* G3R)/2
      T01I=( T00I+ DZ* G3I)/2
      T10R=(4 * T01R- T00R)/3
C
C     TEST CONVERGENCE OF 3 POINT ROMBERG RESULT.
C
      T10I=(4* T01I- T00I)/3
      DEN= ABS( T10R)
      TE1R= ABS( T10I)
      IF( DEN.LT. TE1R) DEN= TE1R
      IF( DEN.LT.1.D-37) GOTO 1001
      TE1R= ABS(( T01R- T10R)/ DEN)
      TE1I= ABS(( T01I- T10I)/ DEN)
      IF( TE1I- CNVLIM) 5,5,6
    5 IF( TE1R- CNVLIM) 8,8,6
 1001 TE1R=0
      TE1I=0
    8 SGR= SGR+ T10R
      SGI= SGI+ T10I
      NT= NT+2
      GOTO 10
    6 VZP= VZ+ DZ*0.25
      CALL GF( VZP, G2R, G2I)
      VZP= VZ+ DZ*0.75D0
      CALL GF( VZP, G4R, G4I)
      T02R=( T01R+ DZOT*( G2R+ G4R))/2
      T02I=( T01I+ DZOT*( G2I+ G4I))/2
      T11R=(4* T02R- T01R)/3
      T11I=(4* T02I- T01I)/3
      T20R=(16* T11R- T10R)/15
C
C     TEST CONVERGENCE OF 5 POINT ROMBERG RESULT.
C
      T20I=(16* T11I- T10I)/15
      DEN= ABS( T20R)
      TE2R= ABS( T20I)
      IF( DEN.LT. TE2R) DEN= TE2R
      IF( DEN.LT.1.D-37) GOTO 2001
      TE2R= ABS(( T11R- T20R)/ DEN)
      TE2I= ABS(( T11I- T20I)/ DEN)
      IF( TE2I- CNVLIM) 7,7,14
    7 IF( TE2R- CNVLIM) 9,9,14
 2001 TE2R=0
      TE2I=0
    9 SGR= SGR+ T20R
      SGI= SGI+ T20I
      NT= NT+1
   10 VZ= VZ+ DZ
      IF( VZ- VZEND) 11,17,17
   11 G1R= G5R
      G1I= G5I
      IF( NT- NTS) 1,12,12
C
C     DOUBLE STEP SIZE
C
   12 IF( NS- 1) 1,1,13
   13 NS= NS/2
      NT=1
      GOTO 1
   14 NT=0
      IF( NS- NMX) 16,15,15
   15 WRITE(*,20)  VZ
   20 FORMAT(' STEP SIZE LIMITED AT Z=',F10.5)
C
C     HALVE STEP SIZE
C
      GOTO 9
   16 NS= NS*2
      FNS= NS
      DZ= S/ FNS
      DZOT= DZ*0.5
      G5R= G3R
      G5I= G3I
      G3R= G2R
      G3I= G2I
      GOTO 4
   17 CONTINUE


C
C     ADD CONTRIBUTION OF NEAR SINGULARITY FOR DIAGONAL TERM
C
      IF( IJ) 19,18,19
   18 SGR=2.*( SGR+ LOG(( SQRT( B* B+ S* S)+ S)/ B))
      SGI=2.* SGI
   19 CONTINUE


C
      RETURN
      END
