      SUBROUTINE SOLGF(ZA,ZB,IP,NP,NEQ)
C     SUBROUTINE SOLVES, FOR SYMMETRIC STRUCTURES, HANDLES THE
C     TRANSFORMATION OF THE RIGHT HAND SIDE VECTOR AND SOLUTION OF THE
C     MATRIX EQ.
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      COMMON  /SMAT/ ZSSX(16,16)
      COMMON  /SCRATM/ ZY(16)
      INCLUDE 'matpar.inc'
      DIMENSION  ZA(1), IP(1), ZB( NEQ, 1)
      NPEQ= NP
      NOP= NEQ/ NPEQ
      FNOP= NOP
      FNORM=1/ FNOP
      NROW= NEQ
      IF( NOP.EQ.1) GOTO 11
      IC=1
C
C     TRANSFORM MATRIX EQ. RHS VECTOR ACCORDING TO SYMMETRY MODES
C
    5 CONTINUE
    6 DO 10  I=1, NPEQ
      DO 7  K=1, NOP
      IA= I+( K-1)* NPEQ
    7 ZY( K)= ZB( IA, IC)
      ZSUM= ZY(1)
      DO 8  K=2, NOP
    8 ZSUM= ZSUM+ ZY( K)
      ZB( I, IC)= ZSUM* FNORM
      DO 10  K=2, NOP
      IA= I+( K-1)* NPEQ
      ZSUM= ZY(1)
      DO 9  J=2, NOP
    9 ZSUM= ZSUM+ ZY( J)* CONJG( ZSSX( K, J))
   10 ZB( IA, IC)= ZSUM* FNORM
   11 CONTINUE
C     SOLVE EACH MODE EQUATION
   12 DO 16  KK=1, NOP
      IA=( KK-1)* NPEQ+1
      IB= IA
   13 IC=1
   14 CALL SOLVE( NPEQ, ZA( IB), IP( IA), ZB( IA, IC), NROW)
   16 CONTINUE
C
C     INVERSE TRANSFORM THE MODE SOLUTIONS
C
      IF( NOP.EQ.1) RETURN
      IC=1
      DO 20  I=1, NPEQ
      DO 17  K=1, NOP
      IA= I+( K-1)* NPEQ
   17 ZY( K)= ZB( IA, IC)
      ZSUM= ZY(1)
      DO 18  K=2, NOP
   18 ZSUM= ZSUM+ ZY( K)
      ZB( I, IC)= ZSUM
      DO 20  K=2, NOP
      IA= I+( K-1)* NPEQ
      ZSUM= ZY(1)
      DO 19  J=2, NOP
   19 ZSUM= ZSUM+ ZY( J)* ZSSX( K, J)
   20 ZB( IA, IC)= ZSUM
      RETURN
      END
